LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY bcff IS 
	port
	(
		LIN :  INOUT  STD_LOGIC_VECTOR(0 DOWNTO 0);
		LOUT : INOUT STD_LOGIC_VECTOR(0 DOWNTO 0);
		ROUT : INOUT STD_LOGIC_VECTOR(0 DOWNTO 0);
		RIN :  INOUT  STD_LOGIC_VECTOR(0 DOWNTO 0)
	);
END bcff;

ARCHITECTURE concept OF bcff IS

component bus_relay
generic     (N : positive :=1);
port        (IO1 : inout std_logic_vector(N-1 downto 0);
             S   : in std_logic_vector(1 downto 0);
             IO2 : inout std_logic_vector(N-1 downto 0) );
end component;

component diode
port 
	(
	  p_Out : out std_logic;
	  p_In : in std_logic
	);
end component;

signal  wire2 :  STD_LOGIC_VECTOR(1 DOWNTO 0);
signal  wire3 :  STD_LOGIC_VECTOR(1 DOWNTO 0);

BEGIN
	
LOUT <= NOT(RIN);
b1: bus_relay port map(LIN,wire2,LOUT);

ROUT <= NOT(LIN);
b2: bus_relay port map(RIN,wire3,ROUT);

END;